-- BagInfosWindow.lua
-- written by Habna


function frmBagInfos()
	frmBI = true;
	tbackpack = backpack;
	SelCN = PN;
	import (AppClassD.."ComboBox");
	BICB = HabnaPlugins.TitanBar.Class.ComboBox();

	-- **v Set some window stuff v**
	wBI = Turbine.UI.Lotro.Window();
	wBI:SetText( L["BIh"] );
	wBI:SetPosition( BIWLeft, BIWTop );
	wBI:SetSize( 390, 560 );
	wBI:SetWantsKeyEvents( true );
	wBI:SetVisible( true );
	--wBI:SetZOrder( 2 );
	--wBI:Activate();

	wBI.KeyDown = function( sender, args )
		if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
			wBI:Close();
		elseif ( args.Action == 268435635 ) or ( args.Action == 268435579 ) then -- Hide if F12 key is press or reposition UI
			wBI:SetVisible( not wBI:IsVisible() );
		end
	end

	wBI.MouseMove = function( sender, args )
		if dragging then BICB:CloseDropDown(); end
	end

	wBI.MouseDown = function( sender, args )
		dragging = true;
	end

	wBI.MouseUp = function( sender, args )
		dragging = false;
		settings.BagInfos.L = string.format("%.0f", wBI:GetLeft());
		settings.BagInfos.T = string.format("%.0f", wBI:GetTop());
		BIWLeft, BIWTop = wBI:GetPosition();
		SaveSettings( false );
	end

	wBI.Closing = function( sender, args ) -- Function for the Upper right X icon
		BICB.dropDownWindow:SetVisible(false);
		wBI:SetWantsKeyEvents( false );
		RemoveCallback( tbackpack, "ItemAdded" );
		RemoveCallback( tbackpack, "ItemRemoved" );
		wBI = nil;
		frmBI = nil;
	end
	-- **^
	-- **v Create drop down box v**
	BICB:SetParent( wBI );
	BICB:SetSize( 159, 19 );
	BICB:SetPosition( 15, 35 );

	BICB.dropDownWindow:SetParent( wBI );
	BICB.dropDownWindow:SetPosition(BICB:GetLeft(), BICB:GetTop() + BICB:GetHeight()+2);

	BICB.ItemChanged = function () -- The event that's executed when a menu item is clicked.
		wBI.SearchTextBox:SetText( "" );
		wBI.SearchTextBox.TextChanged( sender, args );
		SelCN = BICB.label:GetText();
		CountBIItems();
	end

	CreateBIComboBox();
	-- **^
	-- **v search label & text box v**
	wBI.searchLabel = Turbine.UI.Label();
    wBI.searchLabel:SetParent( wBI );
    wBI.searchLabel:SetText( L["VTSe"] );
    wBI.searchLabel:SetPosition( 15, 60 );
    wBI.searchLabel:SetSize( wBI.searchLabel:GetTextLength() * 8, 18 ); --Auto size with text lenght
    wBI.searchLabel:SetFont( Turbine.UI.Lotro.Font.TrajanPro15 );
    wBI.searchLabel:SetForeColor( Color["gold"] );
	 
    wBI.SearchTextBox = Turbine.UI.Lotro.TextBox();
    wBI.SearchTextBox:SetParent( wBI );
    wBI.SearchTextBox:SetPosition(  wBI.searchLabel:GetLeft() +  wBI.searchLabel:GetWidth(),  wBI.searchLabel:GetTop() );
    wBI.SearchTextBox:SetSize( wBI:GetWidth() - 150, 18 );
    wBI.SearchTextBox:SetFont( Turbine.UI.Lotro.Font.Verdana14 );
	wBI.SearchTextBox:SetMultiline( false );
	
    wBI.SearchTextBox.TextChanged = function( sender, args )
        wBI.searchText = string.lower( wBI.SearchTextBox:GetText() );
        if wBI.searchText == "" then wBI.searchText = nil; end
        CountBIItems();
    end

	wBI.SearchTextBox.FocusLost = function( sender, args )
		
	end
	-- **^
	--**v clear search text box icon v**
	wBI.DelIcon = Turbine.UI.Label();
	wBI.DelIcon:SetParent( wBI );
	wBI.DelIcon:SetPosition( wBI.SearchTextBox:GetLeft() + wBI.SearchTextBox:GetWidth() + 5, wBI.SearchTextBox:GetTop() );
	wBI.DelIcon:SetSize( 16, 16 );
	wBI.DelIcon:SetBackground( 0x4101f893 );
	wBI.DelIcon:SetBlendMode( 4 );
	wBI.DelIcon:SetVisible( true );
				
	wBI.DelIcon.MouseClick = function( sender, args )
		wBI.SearchTextBox:SetText( "" );
		wBI.SearchTextBox.TextChanged( sender, args );
		wBI.SearchTextBox:Focus();
	end
	-- **^
	-- **v Set the item listbox border v**
	wBI.ListBoxBorder = Turbine.UI.Control();
	wBI.ListBoxBorder:SetParent( wBI );
	wBI.ListBoxBorder:SetPosition( 15, wBI.SearchTextBox:GetTop() + wBI.SearchTextBox:GetHeight() + 5 );
	wBI.ListBoxBorder:SetSize( wBI:GetWidth() - 30, 392 );
	wBI.ListBoxBorder:SetBackColor( Color["grey"] );
	wBI.ListBoxBorder:SetVisible( true );
	-- **^
	-- **v Set the item listbox v**
	wBI.ListBox = Turbine.UI.ListBox();
	wBI.ListBox:SetParent( wBI );
	wBI.ListBox:SetPosition( wBI.ListBoxBorder:GetLeft() + 2, wBI.ListBoxBorder:GetTop() + 2 );
	wBI.ListBox:SetSize( wBI.ListBoxBorder:GetWidth() - 4, wBI.ListBoxBorder:GetHeight() - 4 );
	wBI.ListBox:SetMaxItemsPerLine( 1 );
	wBI.ListBox:SetOrientation( Turbine.UI.Orientation.Horizontal );
	wBI.ListBox:SetBackColor( Color["black"] );
	-- **^
	-- **v Set the listbox scrollbar v**
	wBI.ListBoxScrollBar = Turbine.UI.Lotro.ScrollBar();
	wBI.ListBoxScrollBar:SetParent( wBI.ListBox );
	wBI.ListBoxScrollBar:SetPosition( wBI.ListBox:GetWidth() - 10, 0 );
	wBI.ListBoxScrollBar:SetSize( 12, wBI.ListBox:GetHeight() );
	wBI.ListBoxScrollBar:SetOrientation( Turbine.UI.Orientation.Vertical );
	wBI.ListBox:SetVerticalScrollBar( wBI.ListBoxScrollBar );
	-- **^
	-- **v Show used slot info in tooltip? v**
	wBI.UsedSlots = Turbine.UI.Lotro.CheckBox();
	wBI.UsedSlots:SetParent( wBI );
	wBI.UsedSlots:SetPosition( 30, wBI.ListBox:GetTop() + wBI.ListBox:GetHeight() + 6 );
	wBI.UsedSlots:SetText( L["BIUsed"] );
	wBI.UsedSlots:SetSize( wBI.UsedSlots:GetTextLength() * 8.5, 20 );
	wBI.UsedSlots:SetChecked( BIUsed );
	wBI.UsedSlots:SetForeColor( Color["rustedgold"] );

	wBI.UsedSlots.CheckedChanged = function( sender, args )
		_G.BIUsed = wBI.UsedSlots:IsChecked();
		settings.BagInfos.U = _G.BIUsed;
		SaveSettings( false );
		UpdateBackpackInfos();
	end
	-- **^
	-- **v Show max slot in tooltip? v**
	wBI.MaxSlots = Turbine.UI.Lotro.CheckBox();
	wBI.MaxSlots:SetParent( wBI );
	wBI.MaxSlots:SetPosition( 30, wBI.UsedSlots:GetTop() + wBI.UsedSlots:GetHeight() );
	wBI.MaxSlots:SetText( L["BIMax"] );
	wBI.MaxSlots:SetSize( wBI.MaxSlots:GetTextLength() * 8.5, 20 );
	wBI.MaxSlots:SetChecked( BIMax );
	wBI.MaxSlots:SetForeColor( Color["rustedgold"] );

	wBI.MaxSlots.CheckedChanged = function( sender, args )
		_G.BIMax = wBI.MaxSlots:IsChecked();
		settings.BagInfos.M = _G.BIMax;
		SaveSettings( false );
		UpdateBackpackInfos();
	end
	-- **^
	-- **v Delete character infos button v**
	wBI.ButtonDelete = Turbine.UI.Lotro.Button();
	wBI.ButtonDelete:SetParent( wBI );
	wBI.ButtonDelete:SetText( L["ButDel"] );
	wBI.ButtonDelete:SetSize( wBI.ButtonDelete:GetTextLength() * 11, 15 ); --Auto size with text lenght

	wBI.ButtonDelete.Click = function( sender, args )
		PlayerBags[SelCN] = nil;
		SavePlayerBags();
		write(SelCN .. L["BID"]);
		SelCN = PN;
		BICB.selection = -1;
		CreateBIComboBox();
		CountBIItems();
	end
	-- **^

	AddCallback(tbackpack, "ItemAdded", 
		function(sender, args)
		if frmBI then
			if SelCN == PN then SavePlayerBags(); CountBIItems();
			elseif SelCN == L["VTAll"] then CountBIItems(); end
		end
	end);

	--**v Workaround for the ItemRemoved that fire before the backpack was updated (Turnine API issue) v**
	BIItemRemovedTimer = Turbine.UI.Control();
	BIItemRemovedTimer.Update = function( sender, args )
		BIItemRemovedTimer:SetWantsUpdates( false );
		if frmBI then
			if SelCN == PN then SavePlayerBags(); CountBIItems();
			elseif SelCN == L["VTAll"] then CountBIItems(); end
		end
	end

	AddCallback(tbackpack, "ItemRemoved", function(sender, args) BIItemRemovedTimer:SetWantsUpdates( true ); end); --Workaround

	CountBIItems();
end

function CreateBIComboBox()
	-- **v Create an array of character name, sort it, then use it as a reference - label & DropDown box v**
	local newt = {}
	for i in pairs(PlayerBags) do
		if string.sub( i, 1, 1 ) == "~" then PlayerBags[i] = nil; else table.insert(newt, i); end --Delete session play character
	end
	table.sort(newt);
	BICB.listBox:ClearItems();
	BICB:AddItem( L["VTAll"], 0 );
	for k,v in pairs(newt) do
		BICB:AddItem(v, k);
		if v == PN then BICB:SetSelection(k); end
	end
	-- **^
end

function CountBIItems()
	backpackCount = 0;
	wBI.ListBox:ClearItems();
	itemCtl = {};
	titem = nil;

	if SelCN == L["VTAll"] then
		wBI.ButtonDelete:SetEnabled( false );
        for i in pairs(PlayerBags) do
			if i == PN then backpackCount = tbackpack:GetSize();
			else for k, v in pairs(PlayerBags[i]) do backpackCount = backpackCount + 1; end end
            AddBagsPack(i, true);
			backpackCount = 0;
        end
    else
		if SelCN == PN then wBI.ButtonDelete:SetEnabled( false ); backpackCount = tbackpack:GetSize();
		else wBI.ButtonDelete:SetEnabled( true ); for k, v in pairs(PlayerBags[SelCN]) do backpackCount = backpackCount + 1; end end
		AddBagsPack(SelCN, false);
    end
 
    wBI.ButtonDelete:SetPosition( wBI:GetWidth()/2 - wBI.ButtonDelete:GetWidth()/2, wBI.MaxSlots:GetTop()+ wBI.MaxSlots:GetHeight()+5 );
end

function AddBagsPack(n, addCharacterName)
	for i = 1, backpackCount do
		if n == PN then	titem = tbackpack:GetItem(i); if titem ~= nil then itemName = titem:GetName(); else itemName = ""; end
		else titem = PlayerBags[n][tostring(i)]; itemName = PlayerBags[n][tostring(i)].T; end

		if not wBI.searchText or string.find(string.lower( itemName ), wBI.searchText, 1, true) then
			-- Item control
			itemCtl[i] = Turbine.UI.Control();
			itemCtl[i]:SetSize( wBI.ListBox:GetWidth() - 10, 35 );

			if n == PN then
				-- Item Background/Underlay/Shadow/Image
				local itemBG = Turbine.UI.Lotro.ItemControl( titem );
				itemBG:SetParent( itemCtl[i] );
				itemBG:SetSize( 34, 34 );
				itemBG:SetPosition( 0, 0 );
			else
				-- Item Background
				local itemBG = Turbine.UI.Control();
				itemBG:SetParent( itemCtl[i] );
				itemBG:SetSize( 32, 32 );
				itemBG:SetPosition( 3, 3 );
				if PlayerBags[n][tostring(i)].B ~= "0" then itemBG:SetBackground( tonumber(PlayerBags[n][tostring(i)].B) ); end
				itemBG:SetBlendMode( Turbine.UI.BlendMode.Overlay );
			
				-- Item Underlay
				local itemU = Turbine.UI.Control();
				itemU:SetParent( itemCtl[i] );
				itemU:SetSize( 32, 32 );
				itemU:SetPosition( 3, 3 );
				if PlayerBags[n][tostring(i)].U ~= "0" then itemU:SetBackground( tonumber(PlayerBags[n][tostring(i)].U) ); end
				itemU:SetBlendMode( Turbine.UI.BlendMode.Overlay );
			
				-- Item Shadow
				local itemS = Turbine.UI.Control();
				itemS:SetParent( itemCtl[i] );
				itemS:SetSize( 32, 32 );
				itemS:SetPosition( 3, 3 );
				if PlayerBags[n][tostring(i)].S ~= "0" then itemS:SetBackground( tonumber(PlayerBags[n][tostring(i)].S) ); end
				itemS:SetBlendMode( Turbine.UI.BlendMode.Overlay );
			
				-- Item Image
				local item = Turbine.UI.Control();
				item:SetParent( itemCtl[i] );
				item:SetSize( 32, 32 );
				item:SetPosition( 3, 3 );
				if PlayerBags[n][tostring(i)].I ~= "0" then item:SetBackground( tonumber(PlayerBags[n][tostring(i)].I) ); end
				item:SetBlendMode( Turbine.UI.BlendMode.Overlay );

				-- Item Quantity
				local itemQTE = Turbine.UI.Label();
				itemQTE:SetParent( itemCtl[i] );
				itemQTE:SetSize( 32, 15 );
				itemQTE:SetPosition( -4, 16 );
				itemQTE:SetFont( Turbine.UI.Lotro.Font.Verdana12 );
				itemQTE:SetFontStyle( Turbine.UI.FontStyle.Outline );
				itemQTE:SetOutlineColor( Color["black"] );
				itemQTE:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight );
				itemQTE:SetBackColorBlendMode( Turbine.UI.BlendMode.Overlay );
				itemQTE:SetForeColor( Color["nicegold"] );
				itemQTE:SetText( tonumber(PlayerBags[n][tostring(i)].N) );
			end

			-- Item name
			local itemLbl = Turbine.UI.Label();
			itemLbl:SetParent( itemCtl[i] );
			itemLbl:SetSize( itemCtl[i]:GetWidth() - 35, 35 );
			itemLbl:SetPosition( 37, 2 );
			itemLbl:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 );
			itemLbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
			itemLbl:SetBackColorBlendMode( Turbine.UI.BlendMode.Overlay );
			itemLbl:SetForeColor( Color["white"] );

			if titem ~= nil then
				itemLbl:SetText( itemName );
				wBI.ListBox:AddItem( itemCtl[i] );
			end

			if addCharacterName then itemLbl:AppendText( " (" .. n .. ")" ); end
		end
	end
end